import {
  IsNotEmpty,
  IsOptional,
  IsString
} from "class-validator";
import { ChildEntity, Column } from "typeorm";
import { ResponsePrincipal } from '../responses/ResponsePrincipal';
import { ResponseUserGroup } from '../responses/ResponseUserGroup';
import { Principal } from './Principal';

/**
 * Defines the UserGroup interface.
*/
@ChildEntity()
export class UserGroup extends Principal {

  /**
   * The group's name
   */
  @Column()
  @IsNotEmpty()
  @IsString()
  name: string;

  /**
   * The group's description
   */
  @Column({ nullable: true })
  @IsOptional()
  @IsString()
  description?: string;

  public toResponse(): ResponsePrincipal {
    return new ResponseUserGroup(this);
  }
}