import axios from 'axios';
import { config } from '../config';
const base = "http://localhost:" + config.internal_port

let access_token;
let axios_config;

beforeAll(async () => {
	const res = await axios.post(base + '/api/auth/login', { username: "demo", password: "demo" });
	access_token = res.data["access_token"];
	axios_config = {
		headers: { "authorization": "Bearer " + access_token },
		validateStatus: undefined
	};
});

describe('GET /api/openapi.json', () => {
	it('is http 200', async () => {
		const res = await axios.get(base + '/api/openapi.json');
		expect(res.status).toEqual(200);
	});
});
describe('GET /', () => {
	it('is http 404', async () => {
		const res = await axios.get(base + '/', axios_config);
		expect(res.status).toEqual(404);
	});
});
describe('GET /api/teams', () => {
	it('is http 200 && is json', async () => {
		const res = await axios.get(base + '/api/teams', axios_config);
		expect(res.status).toEqual(200);
		expect(res.headers['content-type']).toContain("application/json")
	});
});
